image:
  name: registry.gitlab.com/devsres-com/terraform/pipelines/gitlab-terraform:v0.19.1

stages:
  - init
  - test
  - plan
  - build
  - apply
  - destroy
  - decide
  - pipeline-generator
  - drift

variables:
  TF_ROOT: ${CI_PROJECT_DIR}
  TF_STATE_NAME: default
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${TF_STATE_NAME}  
  ACTION: manual-apply 

cache:
  key: "${TF_ROOT}"
  paths:
    - ${TF_ROOT}/.terraform/
    - ${TF_ROOT}/.terraform.lock.hcl

terraform.init: &terraform_init
  stage: init
  script:
    - echo ${ACTION}
    - echo ${TF_STATE_NAME}
    - cd ${TF_ROOT}
    - gitlab-terraform init

terraform.validate: &terraform_validate
  stage: test  
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform validate
  needs: 
    - terraform.init

terraform.plan: &terraform_plan
  stage: plan  
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  resource_group: ${TF_STATE_NAME}
  artifacts:
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json
  needs: 
    - terraform.validate     

terraform.apply: &terraform_apply
  stage: apply  
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform apply
  resource_group: ${TF_STATE_NAME}
  needs:
    - terraform.plan
  rules:
    - if: '$ACTION == "manual-apply"'
      when: manual    
    - if: '$ACTION == "apply"'


terraform.drift: &terraform_drift
  stage: drift  
  script:
    - cd ${TF_ROOT}
    - terrahelper.sh
  resource_group: ${TF_STATE_NAME}
  needs:
    - terraform.plan  
  rules:
    - if: '$ACTION == "drift"'

terraform.destroy: &terraform_destroy
  stage: destroy  
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform destroy
  resource_group: ${TF_STATE_NAME}
  needs:
    - terraform.plan  
  rules:
    - if: '$ACTION == "manual-destroy"'
      when: manual    
    - if: '$ACTION == "destroy"'
  

terraform.decide: &terraform_decide
  stage: decide  
  script:
    - cd ${TF_ROOT}
    - terrahelper.sh
  artifacts: 
    paths:
    - pipelines/decision.yaml
  needs:
    - terraform.plan     
  rules:
    - if: '$ACTION == "decide"'

terraform.decision: &terraform_decision
  stage: pipeline-generator
  needs:
    - terraform.decide
  trigger:
    include:
    - artifact: pipelines/decision.yaml
      job: "terraform.decide"
    strategy: depend 
  rules:
    - if: '$ACTION == "decide"'
  variables:
    PARENT_PIPELINE_ID: $CI_PIPELINE_ID

